# experiments
.find-emoji: &find-emoji |
  # https://gitlab.com/gitlab-org/gitlab-foss/issues/51676
  # https://github.com/codeclimate/spec/blob/master/SPEC.md#data-types
  # https://docs.gitlab.com/ee/user/project/merge_requests/code_quality.html

  # -----------------------------------------
  #  Write your own code quality tool
  # -----------------------------------------
  function emoji_report() {
    SEARCH=$(grep -rwni "$1" * || echo "🙂") 
    if [ "$SEARCH" != "🙂" ];
    then
      # we found some quality issues
      echo "😡 Failure: we find some $1"
      
      # generate report
      RESULTS="$SEARCH" node --eval '  
        let btoa = (string) => Buffer.from(string).toString("base64")

        let fingerprint = (description, path, line) => `${btoa(description)}-${btoa(path)}-${btoa(line)}`

        let bad_things = process.env.RESULTS
          .split("\n")
          .map(item => item.split(":"))
          .map(item => {
            return {
              fingerprint: fingerprint(item[2].trim(), item[0], item[1]),
              description: item[2].trim(),
              location: {
                path: item[0], 
                lines: {
                  begin: item[1]
                }
              }
            } // return
          })
        
        console.log(JSON.stringify(bad_things, null, 2)) // prettify
      ' > gl-code-quality-report.json

      echo "👮‍R‍eport:"
      cat gl-code-quality-report.json      
      if [ "$EXIT_ON_FAILURE" = true ]; then exit 1; fi
      
    else
      # all is ok
      echo "😃Success: no result, then nod bad things about quality and $1"
      echo "[]" > gl-code-quality-report.json      
    fi
  }
  
  function mushrooms_picking() {
    emoji_report 🍄
  } 

  function ladybird_hunting() {
    emoji_report 🐞
  } 

  function kiwi_picking() {
    emoji_report 🥝
  }
  # how to add data to the json file?
  function orange_picking() {
    emoji_report 🍊
  }

.emoji-linter-module:
  before_script:
    - *find-emoji
  artifacts:
    reports:
      codequality: gl-code-quality-report.json
    paths:
      - ./gl-code-quality-report.json

